/* Extended GCC Assembly using constraints
 * 
 * 
 *	asm ( assembler template 
 *	           : output operands                  // optional 
 *	           : input operands                   // optional 
 *	           : list of clobbered registers      // optional 
 *	           );
 *	        
 *	           
 * Note: If there are a total of n operands (both input and output inclusive), 
 * then the first output operand is numbered 0, continuing in increasing order, 
 * and the last input operand is numbered n-1.
 *  
 * 
 * asm ("mov %0, %[test]" :/ No output s/ : "g" (rb) , [test] "g" (test));
 * asm ("mov %[rb], %[test]" :/ No outputs /: [rb] "g" (rb) , [test] "g" (test));					
 * asm ("mov %0, %1" :/ No outputs /: "g" (rb) , "g" (test));										
 * 
 * 
 */


int a = 10, b = 7, c = 10, d = 7, test;
register int ra __asm ("r4");			//Create a pseudonym for r4 and r5
register int rb __asm ("r5");

void asm_test()
{

	ra = 9;
	rb = 6;
	
	/* Example 1: Move a variable to a register and viceversa using C and exended GCC assembly */
	test = ra;				//test = 9
	test++;					//test = 10
	ra = test;				//ra = 10  (ra = r4)
	
	__asm ("mov %[test], %1" : [test] "=r" (test) : "r" (rb));				//test = rb = 6
	__asm ("add %0, %1, %2"  :"=r"(test) :"r"(test), "r"(0x01));  			//test++
	__asm ("mov %0, %[test]" : "=r" (rb) : [test] "r" (test));				//rb = test = 7 (rb = r5)
	
	/*Example 2: test = a + b*/
	__asm ("add %0, %1, %2\n\t" 			//test = 17
		 :"=r"(test)						// output
		 :"r"(a), "r"(b)					// input
	);  

	/*Example 3: Copy the value of variable "b" to variable "a"*/
	__asm ("mov r4, %1\n\t"				//a = 7
		 "mov %0, r4\n\t"
		 :"=r"(a)						// output
		 :"r"(b)						// input
		 :"r4"							// clobbered register
	);   

}

