#include "MK60D10.h" /* include peripheral declarations */

extern void _add();
extern void asm_test();

void func(register unsigned int result1, register unsigned int result2, register unsigned int result3);

int main(void)
{

	__asm("mov r0, #0x0A");		//Single assembly instruction
	__asm("mov r1, #0x05");
	__asm("bl _add"); 			//Calling assembly function using assembly code. Result: r0 = 0x0F, r1 = 0x05
	_add(); 					//Calling assembly function using C code. Result: r0 = 0x14, r1 = 0x05

	__asm("mov r2, #0x0\n\t" 	//Multiple assembly instruction
			"mov r3, #0x1\n\t"
			"mov r4, #0x2\n\t"
			"mov r5, #0x3"
	);

	asm_test();					//Calling C function which uses extended GCC assembly with constraints
	func(1,2,3);				//Using Local Variables and Arguments
	for(;;) {}
	return 0;
}



void func(register unsigned int result1, register unsigned int result2, register unsigned int result3)
{
	register unsigned int r3 __asm ("r3");
	register unsigned int res __asm ("r4");
	
	__asm ("sadd8 %0, %1, %2"  :"=r"(res) :"r"(result1), "r"(result2));
	__asm ("mov %0, %[result1]" : "=r"(r3) : [result1] "r" (result1));
	__asm ("add %0, %[result3]" : "=r"(r3) : [result3] "r" (result3));
}

